<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 11/10/2004 *
 * ===================                          Last change: 03/18/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : bonus_functions.php                              *
 * -------------------------------------------------------------------- *
 * Short description : Special functions for bonus extension            *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Spezielle Funktion fuer bonus-Erweiterung        *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2011 by Mailer Developer Team                   *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

// This function must be run *BEFORE* a link is removed from table 'mxchange_user_links' !
function addTurboBonus ($mid, $userid, $type) {
	// Shall we add bonus points?
	if (!isBonusRallyeActive()) return false;

	// Init variables
	$sql = ''; $bonus = '0'; $mail = '0'; $column = '';

	// Select SQL command
	switch ($type) {
		case 'bonusid':
			$column = 'bonus_id';
			$bonus = $mid;
			break;

		case 'mailid' :
			$column = 'mail_id';
			$mail = $mid;
			break;

		default:
			logDebugMessage(__FUNCTION__, __LINE__, sprintf("Invalid type %s detected.", $type));
			break;
	} // END - switch

	// Is a column name set?
	if (empty($column)) {
		// No, then abort here
		return false;
	} // END - if

	// Check for entry
	$rank = countSumTotalData($mid, 'bonus_turbo', 'id', $column, true) + 1;

	// Which rank?
	if ($rank == 1) {
		// First rank!
		$points = getConfig('turbo_bonus');
	} else {
		// Anything else so let's explode all entered rank points
		$test = explode(';', getConfig('turbo_rates'));
		if (!empty($test[$rank - 2])) {
			// Level found
			$points = $test[$rank - 2];
		} else {
			// Level not found
			$points = '0.00000';
		}
	}

	// Add points to his account directly
	SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_user_data` SET `turbo_bonus`=`turbo_bonus`+%s WHERE `userid`=%s LIMIT 1",
		array(
			bigintval($userid),
			$points
		), __FUNCTION__, __LINE__);

	// Rember this whole data for displaying ranking list
	SQL_QUERY_ESC("INSERT INTO `{?_MYSQL_PREFIX?}_bonus_turbo` (`userid`, `mail_id`, `bonus_id`, `level`, `points`, `timemark`) VALUES (%s, %s, %s, %s, %s, UNIX_TIMESTAMP())",
		array(
			bigintval($userid),
			bigintval($mail),
			bigintval($bonus),
			$rank,
			$points
		), __FUNCTION__, __LINE__);

	if ((isExtensionInstalledAndNewer('bonus', '0.3.5')) && (getBonusMode() != 'ADD') && ($points > 0)) {
		handleBonusPoints($points);
	} // END - if
}

//
function addBonusRanks ($data, $type, $userid) {
	// Init variables
	$self = false; $OUT = ''; $GLOBALS['ranking_content'] = array();

	// Clear rankings by default
	$GLOBALS['ranking_content']['rankings'] = '';

	// How many ranks do we have?
	$ranks = count(explode(';', getConfig('turbo_rates'))) + 1;

	// Load current user's data
	$result = SQL_QUERY_ESC("SELECT `level`, `points`, `timemark` FROM `{?_MYSQL_PREFIX?}_bonus_turbo` WHERE `%s`=%s AND `userid`=%s LIMIT 1",
		array(
			$type,
			$data,
			bigintval($userid)
		), __FUNCTION__, __LINE__);

	// Entry found?
	if (SQL_NUMROWS($result) == 1) {
		// Load data
		$GLOBALS['ranking_content'] = merge_array($GLOBALS['ranking_content'], SQL_FETCHARRAY($result));

		// Remember all values for later use
		$self  = true;

		// Transfer data to template
		$GLOBALS['ranking_content']['timemark'] = generateDateTime($GLOBALS['ranking_content']['timemark'], 1);

		// Load template
		$GLOBALS['ranking_content']['own'] = loadTemplate('show_bonus_yr', true, $GLOBALS['ranking_content']);
	} // END - if

	// Load rankings
	$result = SQL_QUERY_ESC("SELECT `id` FROM `{?_MYSQL_PREFIX?}_bonus_turbo` WHERE `%s`=%s ORDER BY `level` ASC LIMIT {?bonus_lines?}",
		array($type, $data), __FUNCTION__, __LINE__);
	if (!SQL_HASZERONUMS($result)) {
		// Output all ranks (levels)
		for ($rank = 1; $rank <= SQL_NUMROWS($result); $rank++) {
			// Load data
			$result_users = SQL_QUERY_ESC("SELECT
	`userid`, `points`
FROM
	`{?_MYSQL_PREFIX?}_bonus_turbo`
WHERE
	`%s`=%s AND
	`level`=%s
LIMIT 1",
				array($type, $data, $rank), __FUNCTION__, __LINE__);

			// Nothing found by default
			$rows['userid'] = '---';
			$rows['points'] = '---';

			// Are you one of them?
			if (SQL_NUMROWS($result_users) == 1) {
				// Load data
				$rows = merge_array($rows, SQL_FETCHARRAY($result_users));

				// Is ext-nickname active?
				if (isExtensionActive('nickname')) {
					// Then get the nickname
					$nick = getNickname($rows['userid']);

					// Is it not empty? Then use it
					if (!empty($nick)) $rows['userid'] = $nick;
				} // END - if
			} // END - if

			// Free result
			SQL_FREERESULT($result_users);

			// Add more
			$rows['rank'] = $rank;

			// Load row template
			$OUT .= loadTemplate('member_bonus_turbo_row', true, $rows);
		} // END - for

		if ($self === false) {
			// If current user was not found set constant
			$GLOBALS['ranking_content']['rankings'] = '{--MEMBER_BONUS_RANK_YOU_ARE_404--}';
		} // END - if
	} else {
		// No entries found
		// @TODO Move this HTML to a template
		$OUT = '<tr>
  <td colspan="3" align="center" height="30" class="bottom">
    <div class="notice">' . getMaskedMessage('MEMBER_BONUS_NO_RANKS', $data) . '</div>
  </td>
</tr>';
	}

	// Retutn content
	return $OUT;
}

//
function handleBonusPoints ($mode) {
	// Shall we add bonus points?
	if (!isBonusRallyeActive()) return;

	// Switch to jackpot-mode when no UID is supplied but userid-mode is selected
	if ((getBonusMode() == 'UID') && (getBonusUserId() == '0') && (isExtensionActive('jackpot'))) {
		// Update database & config
		updateConfiguration('bonus_mode', 'JACKPOT');
	} // END - if

	if ($mode == 'login_bonus') {
		// Login bonus detected
		$points = getConfig('login_bonus');
	} else {
		// Direct points supplied
		$points = $mode;
	}

	// Check his amount first
	$total = getTotalPoints(getBonusUserId());

	// Subtract points from...
	switch (getBonusMode()) {
		case 'ADD': // Only add them (no subtraction)
			// Ignored
			break;

		case 'JACKPOT': // ... jackpot
			if ((isExtensionActive('jackpot')) && (subtractPointsFromJackpot($points) == -1) && (isValidUserId(getBonusUserId()))) {
				if ($total >= $points) {
					// Subtract points from userid's account
					subtractPointsFromJackpot('bonus_payout_jackpot', getBonusUserId(), $points);
				} // END - if
			} // END - if
			break;

		case 'UID': // ... userid's account
			if ($total >= $points) {
				// Subtract points from userid's account
				subtractPoints('bonus_payout_userid', getBonusUserId(), $points);
			} elseif (isExtensionActive('jackpot')) {
				// Try to subtract from jackpot
				$dummy = subtractPointsFromJackpot($points);
			}
			break;

		default: // This should not happen
			debug_report_bug(__FUNCTION__, __LINE__, 'Invalid bonus-mode ' . getBonusMode() . ' detected.');
			break;
	} // END - switch
}

// Purges expired fast-click bonus entries
function purgeExpiredTurboBonus() {
	// Remove entries
	$result = SQL_QUERY('DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_bonus_turbo` WHERE `timemark` < (UNIX_TIMESTAMP() - {?bonus_timeout?})', __FUNCTION__, __LINE__);

	if (!SQL_HASZEROAFFECTED()) {
		// Send out email to admin
		sendAdminNotification('{--ADMIN_AUTOPURGE_TURBO_SUBJECT--}', 'admin_autopurge_turbo', SQL_AFFECTEDROWS());
	} // END - if
}

//-----------------------------------------------------------------------------
//                                Filter Functions
//-----------------------------------------------------------------------------

// Filter for adding login bonus to the user's account
function FILTER_ADD_LOGIN_BONUS () {
	// Is the user data valid?
	if (!isMember()) {
		// Do only run for logged in members
		debug_report_bug(__FUNCTION__, __LINE__, 'Please only run this filter for logged in users.');
	} // END - if

	// Bonus is not given by default ;-)
	$bonus = false;
	if ((isExtensionInstalledAndNewer('sql_patches', '0.2.8')) && (isBonusRallyeActive()) && (getConfig('bonus_login_yn') == 'Y')) {
		// Update last login if far enougth away
		// @TODO This query isn't right, it will only update if the user was for a longer time away!
		SQL_QUERY_ESC('UPDATE
	`{?_MYSQL_PREFIX?}_user_data`
SET
	`last_login`=UNIX_TIMESTAMP()
WHERE
	`userid`=%s AND
	`last_login` < (UNIX_TIMESTAMP() - {?login_timeout?})
LIMIT 1',
			array(
				getMemberId()
			), __FUNCTION__, __LINE__
		);

		// Updated entry?
		$bonus = (!SQL_HASZEROAFFECTED());
	} // END - if

	if (($bonus === true) && (getRequestParameter('mode') == 'bonus')) {
		// Output message with added points
		$GLOBALS['message'] .= '<div class="tiny">{--MEMBER_BONUS_LOGIN_BONUS_ADDED--}</div>';
	} elseif (isExtensionActive('bonus')) {
		// No login bonus added!
		$GLOBALS['message'] .= '<div class="notice">{--MEMBER_BONUS_LOGIN_BONUS_NOT_ADDED--}</div>';
	}
}

//-----------------------------------------------------------------------------
//                             Wrapper Functions
//-----------------------------------------------------------------------------

// Determines wether the "bonus rallye" is active
function isBonusRallyeActive () {
	// Do we have cache?
	if (!isset($GLOBALS['bonus_rallye_active'])) {
		// Just determine it
		$GLOBALS['bonus_rallye_active'] = (getConfig('bonus_active') == 'Y');
	} // END - if

	// Return cache
	return $GLOBALS['bonus_rallye_active'];
}

// Determines wether the "bonus new_member_notify" is active
function isBonusNewMemberNotifyEnabled () {
	// Do we have cache?
	if (!isset($GLOBALS['bonus_new_member_notify_active'])) {
		// Just determine it
		$GLOBALS['bonus_new_member_notify_active'] = (getConfig('bonus_new_member_notify') == 'Y');
	} // END - if

	// Return cache
	return $GLOBALS['bonus_new_member_notify_active'];
}

// Getter for bonus_timeout
function getBonusTimeout () {
	// Do we have cache?
	if (!isset($GLOBALS[__FUNCTION__])) {
		// Determine it
		$GLOBALS[__FUNCTION__] = getConfig('bonus_timeout');
	} // END - if

	// Return cache
	return $GLOBALS[__FUNCTION__];
}

// Getter for bonus_mode
function getBonusMode () {
	// Do we have cache?
	if (!isset($GLOBALS[__FUNCTION__])) {
		// Determine it
		$GLOBALS[__FUNCTION__] = getConfig('bonus_mode');
	} // END - if

	// Return cache
	return $GLOBALS[__FUNCTION__];
}

// Getter for bonus_ranks
function getBonusRanks () {
	// Do we have cache?
	if (!isset($GLOBALS[__FUNCTION__])) {
		// Determine it
		$GLOBALS[__FUNCTION__] = getConfig('bonus_ranks');
	} // END - if

	// Return cache
	return $GLOBALS[__FUNCTION__];
}

// [EOF]
?>
