<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 09/05/2003 *
 * ===================                          Last change: 07/13/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-overview.php                                *
 * -------------------------------------------------------------------- *
 * Short description : Generate a simple task list or menu descriptions *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Einfache Task-Liste oder Menuebeschreibungen     *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2011 by Mailer Developer Team                   *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Is sql_patches not yet installed?
if (!isExtensionInstalled('sql_patches')) {
	// Output warning
	loadTemplate('admin_settings_saved', false, '{--ADMIN_WARNING_SQL_PATCHES_MISSING--}');
} // END - if

 // Load include file 'overview-inc' (old standard overview page)
loadIncludeOnce('inc/modules/admin/overview-inc.php');

// Default is that all jobs are done (why?)
$jobsDone = true;

// Default is that 'task' is not installed
$taskExt = false;

// When the admin is logging in check several things first (new jobs to complete and so on)
if (getAction() == 'login') {
	if ((isExtensionActive('task')) && (function_exists('outputAdvancedOverview'))) {
		// When task extension is registered output advanced overview page
		$jobsDone = outputAdvancedOverview($result_tasks); // This function is provided by the extension 'task'
		$taskExt = true;
	} else {
		// Output standart overview (provided by overview-inc.php)
		$jobsDone = outputStandardOverview($result_tasks);
	}
} // END - if

// Are we in 'welcome' page and are there jobs to be done?
if (!ifAdminMenuHasEntries(getAction())) {
	// This menu is empty and so no content is displayed
	loadTemplate('admin_settings_saved', false, getMaskedMessage('ADMIN_MENU_IS_EMPTY', getAction()));
} elseif ($jobsDone === true) {
	// Generate overview of all main menus
	if ((is_array($GLOBALS['menu']['description'])) && (count($GLOBALS['menu']['description']) > 0)) {
		$OUT = '';
		foreach ($GLOBALS['menu']['description'] as $key => $value) {
			// Prepare content
			$content = array(
				'title' => $GLOBALS['menu']['title'][$key],
				'text'  => $value
			);

			// Load row template
			$OUT .= loadTemplate('admin_menu_hints_row', true, $content);
		} // END - foreach

		// Load base template
		loadTemplate('admin_menu_hints', false, $OUT);
	}
} elseif ($taskExt === false) {
	if (isExtensionActive('task')) {
		// Output warning message
		loadTemplate('admin_settings_saved', false, getMaskedMessage('EXTENSION_WARNING_EXTENSION_INACTIVE', 'task'));
	} // END - if

	// List selected tasks on overview when task management is not active
	outputSeletectedTasks(postRequestArray(), $result_tasks);
}

// [EOF]
?>
